<?php 
/* SVN FILE: $Id$ */

/**
 * Custom Template Class
 *
 * @copyright Copyright(c) 2005-2009 Ministero per i beni e le attivit culturali. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * Museo & Web CMS is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 *
 * @author		Daniele Ugoletti <daniele.ugoletti@gruppometa.it>, Gruppo Meta <http://www.gruppometa.it>
 * @version		$Id: CustomTemplate.php,$
 * @package		Museo&Web CMS
 * @category	Class
 */

class org_minervaeurope_museoweb_CustomTemplate
{
	var $_template;
	var $_content;
	var $_currentMenu;
	var $_application;
	var $_owner;
	
	function setOwner(&$owner)
	{
		$this->_content 	= array();
		$this->_owner 		= &$owner;
		$this->_template 	= &$owner->_template;
		$this->_currentMenu = &$owner->_currentMenu;
		$this->_application = &$owner->_application;
	}
	
	function processImages()
	{
	}
	
	function processColors()
	{
	}
	
	function processBoxes()
	{
	}
	
	function processDC()
	{
		$this->_content['dc'] = <<<EOD
<meta http-equiv="content-language" content="##language##" />
<meta name="Generator" content="Museo &amp; Web CMS - Copyright (C) 2005, 2012 Ministero per i beni e le attivit&agrave; culturali" />
<meta name="keywords" content="##keywords##" />
<link rel="schema.DC" href="http://purl.org/dc/elements/1.1/" />
<meta name="DC.Title" content="##title##" />
<meta name="DC.Creator" content="##Creator##" />
<meta name="DC.Subject" content="##Subject##" />
<meta name="DC.Description" content="##Description##" />
<meta name="DC.Publisher" content="##Publisher##" />
<meta name="DC.Contributor" content="##Contributor##" />
<meta name="DC.Date" content="(SCHEME=ISO8601) ##Date##" />
<meta name="DC.Type" content="##Type##" />
<meta name="DC.Format" content="(SCHEME=IMT) text/html" />
<meta name="DC.Identifier" content="##Identifier##" />
<meta name="DC.Source" content="##Source##" />
<meta name="DC.Language" content="(SCHEME=ISO639-1) ##language##" />
<meta name="DC.Relation" content="##Relation##" />
<meta name="DC.Coverage" content="##Coverage##" />
<meta name="DC.Rights" content="##Rights##" />
EOD;

		$this->_content['dc'] = str_replace('##language##', 	$this->_application->getLanguage(), 	$this->_content['dc']);
		$this->_content['dc'] = str_replace('##title##', 		$this->_currentMenu->title, 			$this->_content['dc']);
		$this->_content['dc'] = str_replace('##keywords##', 	$this->_currentMenu->keywords, 			$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Creator##', 		$this->_currentMenu->creator, 			$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Subject##', 		$this->_currentMenu->subject, 			$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Description##', 	$this->_currentMenu->description, 		$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Publisher##', 	$this->_currentMenu->publisher, 		$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Contributor##', 	$this->_currentMenu->contributor, 		$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Date##', 		$this->_currentMenu->modificationDate, 	$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Type##', 		$this->_currentMenu->type, 				$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Identifier##', 	$this->_currentMenu->identifier, 		$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Source##', 		$this->_currentMenu->source, 			$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Relation##', 	$this->_currentMenu->relation, 			$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Coverage##', 	$this->_currentMenu->coverage, 			$this->_content['dc']);
		$this->_content['dc'] = str_replace('##Rights##', 		$this->_template['footer'], 			$this->_content['dc']);
	}
	
	function processHiddenNavigation()
	{
		$output  = '<div>'.__T('MW_HIDENNAV_TEXT1').'</div>';
		$output .= '<a href="index.php?pageId=Guida" accesskey="9" title="'.__T('MW_HIDENNAV_TEXT2').'">'.__T('MW_HIDENNAV_TEXT3').'</a><div>|</div>';
		$output .= '<a href="index.php" accesskey="1" title="'.__T('MW_HIDENNAV_TEXT4').'">Home</a><div>|</div>';
		$output .= '<a href="#top-nav" accesskey="2" title="'.__T('MW_HIDENNAV_TEXT5').'">'.__T('MW_HIDENNAV_TEXT6').'</a><div>|</div>';
		$output .= '<a href="#column1_2col" accesskey="3" title="'.__T('MW_HIDENNAV_TEXT7').'">'.__T('MW_HIDENNAV_TEXT8').'</a><div>|</div>';
		$output .= '<a href="#top-smallmenu" accesskey="4" title="'.__T('MW_HIDENNAV_TEXT9').'">'.__T('MW_HIDENNAV_TEXT9').'</a><div>|</div>';
		$output .= '<a href="#content" accesskey="5" title="'.__T('MW_HIDENNAV_TEXT10').'">'.__T('MW_HIDENNAV_TEXT10').'</a>';
		$this->_content['hiddenNav'] = $output;
	}
	

	function render()
	{
		$this->_owner->addOutputCode($this->_content['css'], 		'head');
		$this->_owner->addOutputCode($this->_content['dc'], 		'metaTags');
		$this->_owner->addOutputCode($this->_content['hiddenNav'], 	'hiddenNav');
		
		$this->_owner->addOutputCode($this->_owner->_content['title'], 		'doctitle');
		$this->_owner->addOutputCode($this->_owner->_content['address'], 	'sidebarAddress');
		$this->_owner->addOutputCode($this->_owner->_content['footer'], 	'footer');
	}

}
?>