<?php 
/* SVN FILE: $Id: it.php 220 2008-10-21 23:39:37Z ugoletti $ */

/**
 * Search plugin class
 *
 * @copyright Copyright(c) 2005-2009 Ministero per i beni e le attivit culturali. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * Museo & Web CMS is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 *
 * @author		Daniele Ugoletti <daniele.ugoletti@gruppometa.it>, Gruppo Meta <http://www.gruppometa.it>
 * @version		$Id: Template.php,$
 * @package		Museo&Web CMS
 * @category	Component
 */
 
glz_import('org.glizy.plugins.PluginClient');

class org_minervaeurope_museoweb_search_AbstractSearch extends org_glizy_plugins_PluginClient
{
	function _run(&$parent, $params, $modelName, $title, $description, $fields, $routUrl = "" )
	{
		if ( !empty( $fields ) )
		{
			$fields = ','.$fields;
		}
		if ( empty( $routUrl ) )
		{
			$routUrl = strtolower( $modelName );
		}
		if ( strpos( $modelName, '.' ) === false )
		{
			$modelName = 'org.minervaeurope.museoweb.models.'.$modelName;
		}
		$whereSql = array();
		foreach ($params as $word)
		{
			$whereSql[] = 'UPPER(CONCAT('.$title.','.$description.$fields.')) LIKE UPPER('.org_glizy_dataAccess_DataAccess::qstr('%'.$word.'%').')';
		}
		$it = org_glizy_ObjectFactory::createModelIterator( $modelName, 'all', array('filters' => array('('.implode(' '.__Config::get( 'GLIZY_SEARCH_PLUGIN_CONDITION' ).' ', $whereSql).')')) );
		while ($it->hasMore())
		{
			$arC = &$it->current();
			$it->next();

			$content = $arC->{$title}.$arC->{$description};
			$fieldsName = explode( ',', $fields );
			foreach( $fieldsName as $v )
			{
				if ( !empty( $v ) )
				{
					$content .= $arC->{$v};
				}
			}
			$content = strip_tags( $content );
			$accept = false;
			foreach( $params as $v )
			{
				if ( stripos( $content, $v ) !== false )
				{
					$accept = true;
				}
			}
			
			if ( $accept )
			{
				$values 			= $arC->getValuesAsArray();
				$result 			= $parent->getResultStructure();
				$result['title'] 	= $values[ $title ];
				$result['description'] 	= glz_strtrim( $values[ $description ] );
				$values['title'] 	= $values[ $title ];
				$result['__url__'] 	= org_glizy_helpers_Link::makeLink( $routUrl, $values );
				$parent->addResult($result);
			}
		}

	}
}
?>