<?php
/* SVN FILE: $Id: RoutesController.php 234 2009-02-19 08:30:19Z ugoletti $ */

/**
 * @copyright Copyright(c) 2005-2009 Ministero per i beni e le attività culturali. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * Museo & Web CMS is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 *
 * @author		Daniele Ugoletti <daniele@ugoletti.com>, Gruppo Meta <http://www.gruppometa.it>
 * @package		Museo&Web CMS
 * @category	Component
 */

glz_import('org.glizy.components.HtmlFormElement');

class org_minervaeurope_museoweb_modulesBuilder_SelectTable extends org_glizy_components_HtmlFormElement
{	
	
	// TODO:
	// controllare che sia scrivibile
	// admin/MW/startup
	// MW/classes/userModules
	// admin/MW/
	// 
	
	function init()
	{
		// define the custom attributes
		$this->defineAttribute('cssClass',		false, 	'',		COMPONENT_TYPE_STRING);
		$this->defineAttribute('emptyValue',	false, 	NULL,	COMPONENT_TYPE_STRING);
		$this->defineAttribute('label',			false, 	NULL,	COMPONENT_TYPE_STRING);
		$this->defineAttribute('title',			false, 	NULL,	COMPONENT_TYPE_STRING);
		$this->defineAttribute('rows',			false, 	1,		COMPONENT_TYPE_INTEGER);
		$this->defineAttribute('required',			false, 	false,	COMPONENT_TYPE_BOOLEAN);
		$this->defineAttribute('requiredMessage',	false, 	NULL,	COMPONENT_TYPE_STRING);
		$this->defineAttribute('wrapLabel',		false, 	false,	COMPONENT_TYPE_BOOLEAN);

		// call the superclass for validate the attributes
		parent::init();
	}
	
	function process()
	{	
		$this->_content = $this->_parent->loadContent($this->getId(), $this->getAttribute('bindTo'));
	}
	
	function render()
	{
		$connection = org_glizy_dataAccess_DataAccess::getConnection();
		$rs = $connection->execute( "show tables" );
		$availableTables = array();
		if (!is_null($this->getAttribute('emptyValue')))
		{
			$availableTables[] = html_entity_decode( $this->getAttributeString('emptyValue') );
		}
		
		$tablePrefix = __Config::get( 'DB_PREFIX' );
		$key = null;
		while( !$rs->EOF )
		{
			$current = $rs->fields;
			if ( is_null( $key ) ) {
				$key = array_keys( $current );
				$key = $key[ 0 ];
			} 
			$rs->MoveNext();
			if ( strpos( $current[ $key ], $tablePrefix ) === false && !file_exists( __Paths::get( 'APPLICATION_TO_ADMIN' ).'classes/userModules/'.$current[ $key ] ) )
			{
				$availableTables[] = $current[ $key ];
			}
		}
		
		$attributes 				= array();
		$attributes['id'] 			= $this->getId();
		$attributes['name'] 		= $this->getOriginalId();
		$attributes['class'] 		= $this->getAttribute('required') ? 'required' : '';
		$attributes['class'] 		.= $this->getAttribute( 'cssClass' ) != '' ? ( $attributes['class'] != '' ? ' ' : '' ).$this->getAttribute( 'cssClass' ) : '';
		$attributes['title'] 		= $this->getAttributeString('title');
		$attributes['onchange'] 		= $this->getAttribute('onChange');
		
		if ( $this->getAttribute('rows')>1)
		{
			$attributes['size'] 		= $this->getAttribute('rows');
		}

		$output = '<select '.$this->_renderAttributes($attributes).'>';
		foreach($availableTables as $item)
		{
			$output .= '<option value="'.glz_encodeOutput($item).'">'.glz_encodeOutput($item).'</option>';
		}
		$output .= '</select>';
		
		$output = org_glizy_helpers_Html::label($this->getAttributeString('label'), $this->getId(),  $this->getAttribute('wrapLabel'), $output, array('class' => ($this->getAttribute('required') ? 'required' : '')), false);
		$this->addOutputCode($output);
	}
	
}
?>