<?php
/* SVN FILE: $Id: RoutesController.php 234 2009-02-19 08:30:19Z ugoletti $ */

/**
 * @copyright Copyright(c) 2005-2009 Ministero per i beni e le attivit culturali. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * Museo & Web CMS is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 *
 * @author		Daniele Ugoletti <daniele@ugoletti.com>, Gruppo Meta <http://www.gruppometa.it>
 * @package		Museo&Web CMS
 * @category	Component
 */

glz_import('org.glizy.components.StateSwitchClass');

class org_minervaeurope_museoweb_modulesBuilder_StateController extends org_glizy_components_StateSwitchClass
{	
	/**
	 * Submit dello step2D,  stata scelta la tabella
	 *
	 * @param string $oldState 
	 * @return void
	 */
	function executeLater_step2Csv( $oldState )
	{
		// controlla se  stato ftto submit
		if ( strtolower( __Request::get( 'action', '' ) ) == 'next' )
		{
			include( dirname( __FILE__ ) .'/libs/CVSimporter.php' );
			// sposta il file caricato nella cache
			
			if(isset($_FILES['mbCsvFile']) && !empty($_FILES['mbCsvFile']) && !empty($_FILES['mbCsvFile']['name']))
			{
				$file 		= $_FILES['mbCsvFile'];
				$file_path 	= $file['tmp_name'];
				$file_name 	= $file['name'];
				$file_destname 	= __Paths::getRealPath( 'CACHE' ).md5( time().$file_name );
				
				if ( move_uploaded_file( $file_path, $file_destname ) )
				{
					$tableName = explode('.', $file_name );

					$tableName = str_replace( array( ' ', ')', '(', '/', '\\' ), '', $tableName[ 0 ] );
					$csv = new CVSimporter();
					$csv->conn = org_glizy_dataAccess_DataAccess::getConnection();
					$csv->set_encoding( __Request::get( 'mbCsvEncoding' ) );
					$csv->file_name = $file_destname;
					$csv->table_name = $tableName;
					$csv->use_csv_header = 1;
					$csv->dropTable = true;
				  	$csv->field_separate_char = __Request::get( 'mbCsvSeparate', ';' );
				  	$csv->field_enclose_char = __Request::get( 'mbCsvEnclose', '""' );
				  	$csv->field_escape_char = __Request::get( 'mbCsvEscape', '\\' );
					$csv->import();
					if ( $csv->error != "" )
					{
						$this->_parent->validateAddError( __T( 'Errore nell\'importazione del file, il formato CVS pu essere errato' ) );
					}
					else
					{
						__Session::set( 'mbTable', $tableName );
						__Session::set( 'mbName', $tableName );
						__Session::set( 'mbTableNew', false );
						$this->_parent->refreshToState( 'step3' );	
					}
				}
				else
				{
					// errore
					$this->_parent->validateAddError( __T( 'Errore nel caricamento del file' ) );
				}
				
				@unlink( $file_destname );
			}
			else
			{
				// errore
				$this->_parent->validateAddError( __T( 'Errore nel caricamento del file' ) );
			}	

		}
	}
	
	/**
	 * Submit dello step2D,  stata scelta la tabella
	 *
	 * @param string $oldState 
	 * @return void
	 */
	function executeLater_step2DB( $oldState )
	{
		// controlla se  stato ftto submit
		if ( strtolower( __Request::get( 'action', '' ) ) == 'next' )
		{
			// controlla la validit della form
			if ( $this->_parent->validate() )
			{
				// memorizza il nome della tabella nella sessione
				// e va allo step successivo
				__Session::set( 'mbTable', __Request::get( 'table' ) );
				__Session::set( 'mbName', __Request::get( 'table' ) );
				__Session::set( 'mbTableNew', false );
				$this->_parent->refreshToState( 'step3' );
			}
		}
	}
	
	function execute_step3( $oldState )
	{
		if ( strtolower( __Request::get( 'action', '' ) ) != 'next' )
		{
			// in fase di modifica il nome del modulo
			// viene passato in get
			if ( __Request::exists( 'mbTable' ) && __Request::exists( 'mbName' ) )
			{
				// cambia il tiolo della pagina
				$c = $this->_parent->getComponentById( "pageTitle" );
				$c->setAttribute( 'value', __T( 'Modifica modulo' ) );
				$c->process();
				
				// imposta il nome della tabella e del modulo
				__Session::set( 'mbTable', __Request::get( 'mbTable' ) );
				__Session::set( 'mbName', __Request::get( 'mbName' ) );
				__Session::set( 'mbTableNew', false );
				
				// imposta altri valori dal file info
				glz_import( 'org.minervaeurope.museoweb.modulesBuilder.builder.*', array( 'Builder.php', 'AbstractCommand.php' ) );
				$builder = org_glizy_ObjectFactory::createObject( 'org.minervaeurope.museoweb.modulesBuilder.builder.Builder' );
				$values = file_get_contents( $builder->getCustomModulesFolder().'/Info' );
				$values = unserialize( $values );
				__Request::set( 'fieldOrder', $values[ 'fieldOrder' ] );
				__Request::set( 'fieldRequired', $values[ 'fieldRequired' ] );
				__Request::set( 'fieldType', $values[ 'fieldType' ] );
				__Request::set( 'fieldSearch', $values[ 'fieldSearch' ] );
				__Request::set( 'fieldListSearch', $values[ 'fieldListSearch' ] );
				__Request::set( 'fieldAdmin', $values[ 'fieldAdmin' ] );
				__Request::set( 'fieldLabel', $values[ 'fieldLabel' ] );
			}

		
			// imposta il nome del modulo
			__Request::set( 'mbName', __Session::get( 'mbName' ) );
		}
	}
	
	function executeLater_step3( $oldState )
	{
		// controlla se  stato fatto submit
		if ( strtolower( __Request::get( 'action', '' ) ) == 'next' )
		{
			// controlla la validit della form
			if ( $this->_parent->validate() )
			{
				$fieldOrder = __Request::get( 'fieldOrder' );
				$fieldSearch = __Request::get( 'fieldSearch' );
				$fieldListSearch = __Request::get( 'fieldListSearch' );
				$fieldAdmin = __Request::get( 'fieldAdmin' );

				$error = false;
				if ( is_null( $fieldSearch ) )
				{
					$error = true;
					$this->_parent->validateAddError( __T( 'Specificare i campi per la ricerca' ) );
				}
				if ( !$error && is_null( $fieldListSearch ) )
				{
					$error = true;
					$this->_parent->validateAddError( __T( 'Specificare i campi per il risultato della ricerca' ) );
				}
				if ( !$error && is_null( $fieldAdmin ) )
				{
					$error = true;
					$this->_parent->validateAddError( __T( 'Specificare i campi per la lista in amministrazione' ) );
				}

				if ( !$error )
				{
					__Request::set( 'fieldName', explode( ',', $fieldOrder ) );
					glz_import( 'org.minervaeurope.museoweb.modulesBuilder.builder.*', array( 'Builder.php', 'AbstractCommand.php' ) );
					$builder = org_glizy_ObjectFactory::createObject( 'org.minervaeurope.museoweb.modulesBuilder.builder.Builder' );
					$builder->execute();
					
					$this->_parent->refreshToState( 'step4' );
				}
			}
		}
	}
	
	function executeLater_step3new( $oldState )
	{
		// controlla se  stato fatto submit
		if ( strtolower( __Request::get( 'action', '' ) ) == 'next' )
		{
				$fieldOrder = __Request::get( 'fieldOrder' );
				__Request::set( 'fieldName', explode( ',', $fieldOrder ) );
				$mbName = __Request::get( 'mbName' );
				$mbTable = strtolower( str_replace( ' ', '', $mbName ) ).'_'.uniqid();
				__Session::set( 'mbTable', $mbTable );
				__Session::set( 'mbTableNew', true );

				glz_import( 'org.minervaeurope.museoweb.modulesBuilder.builder.*', array( 'Builder.php', 'AbstractCommand.php' ) );
				$builder = org_glizy_ObjectFactory::createObject( 'org.minervaeurope.museoweb.modulesBuilder.builder.Builder' );
				$builder->execute();
				$this->_parent->refreshToState( 'step4' );
		}
	}
}


?>