<?php
/* SVN FILE: $Id$ */

/**
 * 
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   glizy.application
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 core class
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */

class org_glizy_Config
{	
	function init()
	{
		$configArray = &org_glizy_Config::_getConfigArray();
	}
	
	function get($code)
	{
		$configArray = &org_glizy_Config::_getConfigArray();
		$value = isset($configArray[$code]) ? $configArray[$code] : NULL;
		if( strstr($value, "{{") != FALSE )
        {
      		preg_match_all( "/\{\{([^\{]*)\}\}/U", $value, $resmatch );
            foreach( $resmatch[1] as $varname)
            {
            	$value = str_replace('{{'.$varname.'}}',  org_glizy_Config::get( $varname ), $value);
            }
        }

		return $value;
	}

	function set($code, $value)
	{
		if ( $value == "true" ) 
		{
			$value = true;
		}
		else if ( $value == "false" ) 
		{
			$value = false;
		}
		
		$configArray = &org_glizy_Config::_getConfigArray();
		$configArray[$code] = $value;
		
		// if ($code=='CHARSET')
		// {
		// 	org_glizy_Request::removeAll();
		// }
	}
	
	function dump()
	{
		$configArray = &org_glizy_Config::_getConfigArray();	
		var_dump($configArray);
	}
	
	function &_getConfigArray()
	{
		// Array associativo (PATH_CODE=>PATH)
		static $_configArray = null;
		if (is_null($_configArray))	
		{
			$_configArray = array();
			org_glizy_Config::_parse();	
		}	
		return $_configArray;
	}	
	
	
	function _parse()
	{
		// imposta i valori di default
		$configArray 						= &org_glizy_Config::_getConfigArray();
		$configArray['DEBUG'] 				= false;
		$configArray['DATASOURCE_MODE'] 	= '';
		$configArray['SESSION_PREFIX'] 		= '';
		$configArray['DEFAULT_LANGUAGE'] 	= 'en';
		$configArray['DEFAULT_LANGUAGE_ID'] = '1';
		$configArray['CHARSET'] 			= 'utf-8';
		$configArray['DB_LAYER'] 			= 'pdo';
		$configArray['DB_TYPE'] 			= 'mysql';
		$configArray['DB_HOST'] 			= '';
		$configArray['DB_NAME'] 			= '';
		$configArray['DB_USER'] 			= '';
		$configArray['DB_PSW'] 				= '';
		$configArray['DB_MYSQL_BUFFERED_QUERY'] = false;
		$configArray['DB_PREFIX'] 			= '';		
		$configArray['DB_SOCKET'] 			= '';		
		$configArray['SMTP_HOST'] 			= '';
		$configArray['SMTP_USER'] 			= '';
		$configArray['SMTP_PSW'] 			= '';
		$configArray['SMTP_SENDER'] 		= '';
		$configArray['SMTP_EMAIL'] 			= '';
		$configArray['START_PAGE'] 			= 'HOME';
		$configArray['CACHE_IMAGES'] 		= -1;
		$configArray['CACHE_CODE'] 			= -1;
		$configArray['CACHE_PAGE']			= -1;
		$configArray['ADM_THUMBNAIL_CROP']	= false;
		$configArray['ADM_THUMBNAIL_CROPPOS']	= 0;
		$configArray['ADM_SITE_MAX_DEPTH']	= NULL;
		$configArray['HIDE_PRIVATE_PAGE']	= true;
		$configArray['APP_NAME'] 			= '';
		$configArray['APP_VERSION'] 		= '';
		$configArray['APP_AUTHOR'] 			= '';
		$configArray['CORE_VERSION'] 		= GLZ_CORE_VERSION;
		$configArray['SEF_URL'] 			= false;
		$configArray['SITEMAP'] 			= 'siteMap.xml';
		$configArray['REMEMBER_PAGEID']		= false;
		$configArray['PSW_METHOD']			= 'MD5';
		$configArray['USER_LOG']			= false;
		$configArray['JS_COMPRESS']			= false;
		$configArray['JPG_COMPRESSION']		= 80;
		$configArray['THUMB_WIDTH']			= 150;
		$configArray['THUMB_HEIGHT']		= 150;
		$configArray['IMG_LIST_WIDTH']		= 100;
		$configArray['IMG_LIST_HEIGHT']		= 100;
		$configArray['IMG_WIDTH_ZOOM'] 		= 800;
		$configArray['IMG_HEIGHT_ZOOM'] 	= 600;
		$configArray['IMG_WIDTH'] 			= 200;
		$configArray['IMG_HEIGHT'] 			= 200;
		$configArray['LOG_FILE']			= '';
		$configArray['LOG_LEVEL']			= GLZ_LOG_ALL;
		$configArray['STATIC_FOLDER']		= NULL;
		$configArray['TEMPLATE_FOLDER']		= NULL;
		$configArray['FORM_ITEM_TEMPLATE']	= '<div class="formItem">##FORM_ITEM##<br /></div>';
		$configArray['FORM_ITEM_RIGHT_LABEL_TEMPLATE']	= '<div class="formItemRigthLabel">##FORM_ITEM##<br /></div>';
		$configArray['FORM_ITEM_HIDEN_TEMPLATE'] = '<div class="formItemHidden">##FORM_ITEM##</div>';
		$configArray['SITE_ID']				= NULL;
		$configArray['ALLOW_MODE_OVERRIDE']	= false;
		$configArray['USER_DEFAULT_ACTIVE_STATE'] = 0;
		$configArray['ACL_ENABLED'] 		= false;
		$configArray['DEFAULT_SKIN_TYPE'] 	= 'PHPTAL';
		$configArray['GLIZY_SEARCH_PLUGIN_CONDITION'] = 'OR';
		$configArray['GLIZY_JS_LIB'] 			= 'jquery';
		$configArray['GLIZY_ADD_CORE_JS'] 		= true;
		$configArray['GLIZY_ADD_JA_JS'] 		= true;
		$configArray['GLIZY_ADD_JS_LIB'] 		= true;
		$configArray['GLIZY_ADD_JQUERYUI_JS'] 	= false;
		$configArray['GLIZY_JQUERY'] 			= 'jquery-1.5.2.min.js';
		$configArray['GLIZY_JQUERYUI'] 			= 'jquery-ui-1.8.10.custom.min.js';
		$configArray['GLIZY_JQUERYUI_THEME'] 	= 'ui-lightness/jquery-ui-1.8.10.custom.css';
		$configArray['GLIZY_MOOTOOLS'] 			= 'mootools-1.2-core-yc.js';
		$configArray['GLIZY_MOOTOOLS_MORE'] 	= 'mootools-1.2-more.js';
		$configArray['TINY_MCE_DEF_PLUGINS'] 	= 'inlinepopups,paste,directionality,xhtmlxtras,fullscreen,GLZ_link,GLZ_image';
		$configArray['TINY_MCE_PLUGINS'] 	= '';
		$configArray['TINY_MCE_BUTTONS1'] 	= 'bold,italic,|,justifyleft,justifycenter,justifyright,justifyfull,|,bullist,numlist,outdent,indent,blockquote';
		$configArray['TINY_MCE_BUTTONS2'] 	= 'formatselect,|,undo,redo,pastetext,pasteword,removeformat,|,link,unlink,anchor,image,hr,charmap,|,code,fullscreen';
		$configArray['TINY_MCE_BUTTONS3'] 	= '';
		$configArray['TINY_MCE_INTERNAL_LINK'] 	= true;
		$configArray['BASE_REGISTRY_PATH'] 			= 'org/glizy';
		$configArray['REGISTRY_TEMPLATE_NAME'] 		= '{{BASE_REGISTRY_PATH}}/templateName';
		$configArray['REGISTRY_TEMPLATE_VALUES'] 	= '{{BASE_REGISTRY_PATH}}/templateValues/';
		$configArray['REGISTRY_SITE_PROP'] 			= '{{BASE_REGISTRY_PATH}}/siteProp/';
		$configArray['REGISTRY_METANAVIGATION'] 	= '{{BASE_REGISTRY_PATH}}/metanavigation/';
						
		$serverName = is_null( $_SERVER["SERVER_NAME"] ) ? 'console' : $_SERVER["SERVER_NAME"];		
		$configFileName = org_glizy_Paths::get('APPLICATION').'config/config_'.$serverName.'.xml';
		
		if (!file_exists($configFileName))
		{
			$configFileName = org_glizy_Paths::get('APPLICATION').'config/config.xml';
		}
		
		if (!file_exists($configFileName))
		{
			return;
		}

		$compiler 		= org_glizy_ObjectFactory::createObject('org.glizy.compilers.Config');
		$compiledConfigFileName = $compiler->verify($configFileName);

		// TODO
		// controllare errore
		include($compiledConfigFileName);
		
		if (!empty($configArray['STATIC_FOLDER']))
		{
			org_glizy_Paths::set('APPLICATION_STATIC', org_glizy_Paths::get('STATIC_DIR').$configArray['STATIC_FOLDER']);
		}
		if (!empty($configArray['TEMPLATE_FOLDER']))
		{
			org_glizy_Paths::set('APPLICATION_TEMPLATE', org_glizy_Paths::get('STATIC_DIR').$configArray['TEMPLATE_FOLDER']);
		}

		if ( $configArray['ALLOW_MODE_OVERRIDE'] && isset( $_GET['mode'] ) )
		{
			org_glizy_Config::setMode( $_GET['mode'] );
		}
		
		define( 'GLZ_CHARSET', __Config::get( 'CHARSET' ) );
	}
	
	function setMode( $modeName )
	{
		$configArray = &org_glizy_Config::_getConfigArray();
		if ( isset( $configArray[ '__modes__'][ $modeName ] ) )
		{
			foreach( $configArray[ '__modes__'][ $modeName ] as $k => $v )
			{
				$configArray[ $k ] = $v;
			}
		}
		else
		{
			// TODO: in modalit debug visualzzare un warning
		}
	}
}

// shortchut version
class __Config extends org_glizy_Config
{
}
?>