<?php

class org_glizy_Routing
{
	static $requestUrl = '';
	static $queryString = '';
	static $baseUrl = '';
	static $baseUrlParam = '';
	
	function org_glizy_Routing()
	{
	}

	function init()
	{
		$configArray = &org_glizy_Routing::_getValuesArray();
		
		$scriptName = $_SERVER["SCRIPT_NAME"];
		self::$requestUrl = $_SERVER["REQUEST_URI"];
		self::$requestUrl = str_replace( array( $scriptName, dirname( $scriptName ).'/' ) , array( '', '' ), self::$requestUrl );
		self::$requestUrl = ltrim( self::$requestUrl, '/' );
		$pos = org_glizy_Config::get('SEF_URL') === 'full' ? strpos( self::$requestUrl, '?' ) : strpos( self::$requestUrl, '&' );
		if ( $pos !== false )
		{
			self::$queryString = substr( self::$requestUrl, $pos + 1);
			self::$requestUrl = substr( self::$requestUrl, 0, $pos );
		}
		self::$requestUrl = trim( self::$requestUrl, '?' );
		
		if ( org_glizy_Config::get('SEF_URL') === 'full' )
		{
			self::$baseUrl = GLZ_HOST.'/';
			self::$baseUrlParam = '?';
		}
		else
		{
			self::$baseUrl = org_glizy_Paths::get('PAGE_INDEX').'?';
			self::$baseUrlParam = '&';
		}	
	}
	
	function dump()
	{
		$params	= &org_glizy_Routing::_getValuesArray();
	}
	

	function scriptUrl( $removeGetParams=false )
	{
		if ( $removeGetParams )
		{
			return self::$baseUrl.self::$requestUrl;
		}
		else
		{
			return self::$baseUrl.self::$requestUrl.( empty( self::$queryString ) ? '' : self::$baseUrlParam.self::$queryString );
		}
	}
	
	function scriptUrlWithParams( $params, $absolute = false )
	{
		$host = $absolute && org_glizy_Config::get('SEF_URL') == true ? GLZ_HOST.'/'  : '';
		$params = preg_replace( '/^&amp;/', '', $params );
		return $host.self::$baseUrl.self::$requestUrl.self::$baseUrlParam.$params;
	}
	
	
	function makeURL($route='', $queryVars=array(), $addParam=array())
	{
		if ( org_glizy_Config::get('SEF_URL') == false)
		{
			return org_glizy_Routing::_makeURL_NOSEF( $route, $queryVars, $addParam );
		}
		else
		{
			return org_glizy_Routing::_makeURL_SEF( $route, $queryVars, $addParam );
		}
	}
	
	function _makeURL_NOSEF($route='', $queryVars=array(), $addParam=array())
	{
		$queryVars = array_merge( $queryVars, $addParam );
		if (!empty($route))
		{
			$configArray = &org_glizy_Routing::_getValuesArray();
			$application = &org_glizy_ObjectValues::get('org.glizy', 'application');
			$siteMap = &$application->getSiteMap();

			
			// TODO
			// controllare se il route richiesto esiste.
			//
			// TODO
			// ci sono molte classi che usano lo stesso concetto di memorizzare
			// i dati in un array statico
			// conviene fare una classe base e estendere questa
			//
			$url = $configArray[strtolower($route)]['value'];
			$pageId = 0;
			preg_match_all("|\{(.*)\}|U", $url, $match, PREG_PATTERN_ORDER);
			for($i=0; $i<count($match[0]); $i++)
			{
				$value = '';
				$key = '';
				$command = explode('=', $match[1][$i]);
				$key = $command[0];
				switch ($command[0])
				{
					case 'language':
						$value = isset($queryVars['language']) ? $queryVars['language'] : $application->getLanguage();
						break;
					case '*':
					case 'currentMenu':
						$page = &$application->getCurrentMenu();
						$value =  $page->id;
						$key = 'pageId';
						break;
					case 'pageId':
						// ricerca la pagina da linkare
						if (count($command)>1)
						{
							if (is_numeric($command[1]))
							{
								$page = $siteMap->getNodeById($command[1]);
							}
							else
							{
								$page = $siteMap->getMenuByPageType($command[1]);
							}
							$value =  $page->id;
						}
						else
						{
							$pageId = $queryVars[$command[0]];
							if ( empty( $pageId ) )
							{
								$page = &$application->getCurrentMenu();
								$pageId =  $page->id;
								unset( $page );
							}
							$value = $pageId;
						}

						break;
					case 'pageTitle':
						continue;
						break;
					case 'value':
					case 'integer':
						$value =  isset($queryVars[$command[1]]) ? $queryVars[$command[1]] : __Request::get( $command[1], '' );
						$key = $command[1];
						break;
					case 'static':
						$value = $command[2];
						$key = $command[1];
						break;
					default:
						$value =  $command[1];
						break;
				}
				if (is_string($value) && empty($value))
				{
					continue;
				}

				if ( !isset( $queryVars[ $key ] ) ) $queryVars[ $key ] = $value;
			}
		}

		$url = '';
		foreach($queryVars as $k=>$v)
		{
			$url .= (!empty($url) ? '&' : '').$k.'='.$v;
		}
		$url = org_glizy_Paths::get('PAGE_INDEX').'?'.$url;
		return $url;
	}
	
	function _makeURL_SEF($route='', $queryVars=array(), $addParam=array())
	{
		if ( !isset( $addParam[ '__modal__' ] ) && __Request::exists( '__modal__' ) )
		{
			$addParam[ '__modal__' ] = __Request::get( '__modal__' );
		}
		
		$url = '';
		if (!empty($route))
		{
			$configArray = &org_glizy_Routing::_getValuesArray();
			$application = &org_glizy_ObjectValues::get('org.glizy', 'application');
			$isApplicationDB = is_a( $application, 'org_glizy_application_ApplicationDB' );
			$siteMap = &$application->getSiteMap();

			// TODO
			// controllare se il route richiesto esiste.
			//
			// TODO
			// ci sono molte classi che usano lo stesso concetto di memorizzare
			// i dati in un array statico
			// conviene fare una classe base e estendere questa
			//
			$routing = $configArray[strtolower($route)];
			if ( isset( $routing[0] ) )
			{
				foreach( $routing as $v )
				{
					if ( $queryVars[ $v[ 'keyName' ] ] == $v[ 'keyValue' ] || empty( $v[ 'keyValue' ] ))
					{
						$url = $v['value'];
						break;
					}
				}
			}
			else
			{
				$url = $routing['value'];
			}
			
			$pageId = 0;
			preg_match_all("|\{(.*)\}|U", $url, $match, PREG_PATTERN_ORDER);
			for($i=0; $i<count($match[0]); $i++)
			{
				$value = '';
				$value2 = '';
				$command = explode('=', $match[1][$i]);
				switch ($command[0])
				{
					case 'language':
						$value = isset($queryVars['language']) ? $queryVars['language'] : $application->getLanguage();
						break;
				case '*':
				case 'currentMenu':
					$page = &$application->getCurrentMenu();
					$value =  $page->id;
					$value2 = $page->title;
					unset( $page );
					break;
				case 'currentMenuId':
					$page = &$application->getCurrentMenu();
					$value =  $page->id;
					unset( $page );
					break;
				case 'pageId':
						// ricerca la pagina da linkare
						if (count($command)>1)
						{
							if (is_numeric($command[1]))
							{
								$page = $siteMap->getNodeById($command[1]);
							}
							else
							{
								$page = $siteMap->getMenuByPageType($command[1]);
								if ( is_null( $page ) )
								{
									$alias = org_glizy_Modules::getModuleAlias( $command[1] );
									if ( !is_null( $alias ) )
									{
										$page = $siteMap->getMenuByPageType($alias);
									}
								}
							}

							$value =  $page->id;
							$value2 = $isApplicationDB ? $page->title : '';
						}
						else
						{
							$pageId = $queryVars[$command[0]];
							if ( empty( $pageId ) )
							{
								$page = &$application->getCurrentMenu();
								$pageId =  $page->id;
								unset( $page );
							}
							$value = $pageId;
							$value2 = '';
						}

						break;
					case 'pageTitle':
						// ricerca la pagina da linkare
						if (!isset($queryVars['title']))
						{
							// TODO
							// non deve instanziare un nuovo men altrimenti rilegge tutto dal db ogni volta
							$page = $siteMap->getNodeById($pageId);
							$value = $page->title;
						}
						else
						{
							$value = $queryVars['title'];
						}
						break;
					case 'routeName':
						$value = $route;
						break;
					case 'value':
					case 'integer':
						$value =  isset($queryVars[$command[1]]) ? $queryVars[$command[1]] : __Request::get( $command[1], '' );
						break;
					case 'static':
						$value =  '';
						break;
					default:
						$value =  $command[1];
						break;
				}
				if (is_string($value) && empty($value))
				{
					$url = str_replace($match[0][$i].'/', '', $url);
					$url = str_replace($match[0][$i], '', $url);
					continue;
				}

				$value = glz_sanitizeUrlTitle($value).($value2!='' ? '/' : '');
				$value2 = glz_sanitizeUrlTitle($value2);
				$url = str_replace($match[0][$i], $value.$value2, $url);
			}

			// aggiunge in coda i valori della query string che non sono usati
			if (count($addParam))
			{
				$url .= self::$baseUrlParam;
				foreach($addParam as $k=>$v)
				{
					$url .= '&'.$k.'='.$v;
				}
			}
		}
		
		$url = !empty($url) ? $url : $route;
		return self::$baseUrl.$url;
	}
	
	function _compile()
	{
		$configArray = &org_glizy_Routing::_getValuesArray();

		// compila il file di routing custom
		$fileName = org_glizy_Paths::getRealPath('APPLICATION', 'config/routing_custom.xml');
		if ( file_exists( $fileName ) )
		{
			$compiler = org_glizy_ObjectFactory::createObject('org.glizy.compilers.Routing');
			$compiledFileName = $compiler->verify($fileName);
			include($compiledFileName);
		}
		
		// compila il file di routing
		$fileName = org_glizy_Paths::getRealPath('APPLICATION', 'config/routing.xml');
		if ( file_exists( $fileName ) )
		{
			$compiler = org_glizy_ObjectFactory::createObject('org.glizy.compilers.Routing');
			$compiledFileName = $compiler->verify($fileName);
			include($compiledFileName);
		}
	}
	
	function _parseUrl()
	{
		$scriptUrl = self::$requestUrl;
		$scriptUrl = preg_replace('/(.*)\/?(\&.*$)/Ui', '$1', $scriptUrl);
		$configArray = &org_glizy_Routing::_getValuesArray();

		foreach( $configArray as $k => $v )
		{
			$routing = !isset( $v[0] ) ? array( $v ) : $v;

			foreach ($routing as $url)
			{
				if ( !$url[ 'parseUrl' ] ) continue;
				$urlPattern = $url[ 'urlPattern' ];
			
				if (preg_match($urlPattern, $scriptUrl, $matches))
				{
					$staticValues = unserialize( $url[ 'staticValues' ] );
					$urlValues = unserialize( $url[ 'urlValues' ] );
					$keys = array_keys($urlValues);
					for ($i=0; $i<count($keys); $i++)
					{
						$value = explode('/', $matches[$i+1]);
						if (!empty($value[0])) 
						{
							$urlValues[$keys[$i]] = $value[0];
						}
						if (count($value)>1)
						{
							for ($j=1; $j<count($value); $j++, $j++)
							{
								if ($j+1<count($value)) $urlValues[$value[$j]] = $value[$j+1];
							}
						}
					}

					$urlValues[ '__routingName__' ] = $k;
					$urlValues[ '__routingPattern__' ] = $urlPattern;

					__Request::setFromArray( array_merge( $urlValues, $staticValues ) );
					break;
				}
			}
		}
	}
	
	function &_getValuesArray()
	{
		// Array associativo (PATH_CODE=>PATH)
		static $_configArray = null;
		if (is_null($_configArray))	
		{
			$_configArray = array();
			org_glizy_Routing::_compile();
		}	
		return $_configArray;
	}
}

// shortchut version
class __Routing extends org_glizy_Routing
{
}
?>