<?php
/* SVN FILE: $Id$ */

/**
 * 
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   glizy.admin
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 core class
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */

glz_import('org.glizy.application.ApplicationXML');

class org_glizy_admin_AdminApplication extends org_glizy_application_ApplicationXML
{	
	var $_pathApplicationToAdmin;
	
	function org_glizy_admin_AdminApplication($pathApplication='', $pathCore='', $pathApplicationToAdmin)
	{
		$this->_pathApplicationToAdmin = $pathApplicationToAdmin;
		org_glizy_ObjectValues::set('org.glizy', 'admin', true);
		org_glizy_Paths::init($pathApplication, $pathCore);	
		org_glizy_Paths::set('APPLICATION_MEDIA_ARCHIVE', $this->_pathApplicationToAdmin.'mediaArchive/');
		org_glizy_Paths::set('CACHE', $this->_pathCore.'../cache/');
		org_glizy_Paths::set('STATIC_DIR', $this->_pathCore.'../static/');
		org_glizy_Paths::set('CORE_STATIC_DIR', $this->_pathCore.'../static/org_glizy/');
		org_glizy_Paths::add('APPLICATION_TO_ADMIN', $this->_pathApplicationToAdmin);
		org_glizy_Paths::add('APPLICATION_TO_ADMIN_PAGETYPE', $this->_pathApplicationToAdmin.'pageTypes/');
		org_glizy_Paths::addClassSearchPath($this->_pathApplicationToAdmin.'classes/');
		//if (org_glizy_Config::get('SESSION_PREFIX')=='') org_glizy_Config::set('SESSION_PREFIX', 'admin');
		parent::org_glizy_application_Application($pathApplication, $pathCore);
	}
	
	
	function _init()
	{
		parent::_init();

	//	$strings = array ('GLZ_DATE_FORMAT' 			=>	"Y-m-d");
	//	org_glizy_locale_Locale::append($strings);
	
		// inizialize the editing language
		$language = org_glizy_Session::get('glizy.editingLanguageId');
		if (is_null($language))
		{
			$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.Language');
			$ar->language_isDefault = 1;
			$ar->language_FK_site_id = org_glizy_Config::get( 'SITE_ID' );
			$ar->find();
			org_glizy_Session::set('glizy.editingLanguage', $ar->language_code);
			org_glizy_Session::set('glizy.editingLanguageId', $ar->language_id);
			org_glizy_Session::set('glizy.editingLanguageIsDefault', $ar->language_isDefault);
		}
	}
	
	function render_onStart()
	{
		$this->addJSLibCore();
	}
	
	function switchEditingLanguage($id)
	{
		$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.Language');
		$ar->load($id);
		org_glizy_Session::set('glizy.editingLanguage', $ar->language_code);
		org_glizy_Session::set('glizy.editingLanguageId', $ar->language_id);
		org_glizy_Session::set('glizy.editingLanguageIsDefault', $ar->language_isDefault);		
	}
	
	function getEditingLanguageId()
	{
		return org_glizy_Session::get('glizy.editingLanguageId');
	}

	function getEditingLanguage()
	{
		return org_glizy_Session::get('glizy.editingLanguage');
	}

	function getEditingLanguageIsDefault()
	{
		return org_glizy_Session::get('glizy.editingLanguageIsDefault');
	}

	function getPathApplicationToAdmin()
	{
		return $this->_pathApplicationToAdmin;
	}
	
	function getLanguageId()
	{
		return 1;
	}

	function getLanguage()
	{
		return !empty($this->_user->language) ? $this->_user->language : parent::getLanguage();
	}
	
	function isAdmin()
	{
		return true;
	}
}
?>
