<?php
/* SVN FILE: $Id$ */

/**
 * 
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   glizy.admin.components
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 admin component
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */
 
glz_import('org.glizy.components.ComponentContainer');
glz_import('org.glizy.helpers.JS');

class org_glizy_admin_components_JSEditing extends org_glizy_components_ComponentContainer
{
	/**
	 * Return the component information
	 * 
	 * @return	array	component informaton.
	 * @access	public
	 * @static
	 */
	function getInfo()
	{
		$info 					= parent::info();
		$info['name']			= 'JSEditing';
		$info['class'] 			= 'org.glizy.admin.components.JSEditing';
		$info['package'] 		= 'Glizy';
		$info['version'] 		= GLZ_CORE_VERSION;
		$info['author'] 		= 'Daniele Ugoletti';
		$info['author-email'] 	= 'daniele@ugoletti.com';
		$info['url'] 			= 'http://www.ugoletti.com';
		return $info;
	}
	
	/**
	 * Init
	 * 
	 * @return	void
	 * @access	public
	 */
	function init()
	{
		$this->acceptOutput = true;
		$this->defineAttribute('controller', 	false, NULL, COMPONENT_TYPE_OBJECT);
		$this->defineAttribute('ajaxPageId', 	false, NULL, COMPONENT_TYPE_STRING);
		$this->defineAttribute('enableFirstSave', 	false, false, COMPONENT_TYPE_BOOLEAN);
		$this->defineAttribute('label', false, '', COMPONENT_TYPE_STRING);
	
		// call the superclass for validate the attributes
		parent::init();
	}
	
	/**
	 * Process
	 * 
	 * @return	boolean	false if the process is aborted
	 * @access	public
	 */
	function process()
	{
		$this->processChilds();
	}

	/**
	 * Render
	 * 
	 * @return	void
	 * @access	public
	 */
	function render()
	{
		$this->_application->addJSLibCore();
		
		$this->renderChilds('jsediting');
		
		$ajaxPageId = $this->getAttribute('ajaxPageId');
		if (is_null($ajaxPageId))
		{
			$ajaxPageId = $this->_application->getPageId();
		}
	
		$stateParam = '';
		$controllerClass 		= &$this->getAttribute('controller');
		if ( is_object( $controllerClass ) && method_exists( $controllerClass, 'currentStateParam' ) )
		{
			$stateParam = $controllerClass->currentStateParam();
		}
		
		$jsOuput  = '<script type="text/javascript">'.GLZ_COMPILER_NEWLINE2;
		$jsOuput .= 'Glizy.pageContent = {};'.GLZ_COMPILER_NEWLINE2;
		$jsOuput .= 'Glizy.pageContent.action = "ajax.php?pageId='.$ajaxPageId.'&ajaxTarget='.$this->getId().$stateParam.'";'.GLZ_COMPILER_NEWLINE2;
		$jsOuput .= 'Glizy.pageContent.imgSrc = "index.php?pageId=imagepicker";'.GLZ_COMPILER_NEWLINE2;
		$jsOuput .= 'Glizy.pageContent.mediaSrc = "index.php?pageId=mediapicker";'.GLZ_COMPILER_NEWLINE2;
		$jsOuput .= 'Glizy.pageContent.thesaurusSrc = "index.php?pageId=thesauruspicker";'.GLZ_COMPILER_NEWLINE2;
		$jsOuput .= 'Glizy.pageContent.enableFirstSave = '.( $this->getAttribute( 'enableFirstSave' ) ? 'true' : 'false' ).GLZ_COMPILER_NEWLINE2;
		
		if (org_glizy_ObjectValues::get('org.glizy.JS.TinyMCE', 'add', false))
		{
			$internalLinks = array();
			if ( __Config::get( 'TINY_MCE_INTERNAL_LINK' ) )
			{
			// questa parte viene aggiunta solo se si usa tinyMCE
			// internal links
			$siteMap = &org_glizy_ObjectFactory::createObject('org.glizy.application.SiteMapDB');
			$siteMap->getSiteArray();
			$siteMapIterator = &org_glizy_ObjectFactory::createObject('org.glizy.application.SiteMapIterator', $siteMap);
			while (!$siteMapIterator->EOF)
			{
				$n = $siteMapIterator->getNodeArray();
				$internalLinks[] = '["'.str_repeat('.  ', $n["depth"]-1).glz_encodeOutput($n['title']).'", "'.$n['id'].'", 0]';
				$siteMapIterator->moveNext();
			}
			}
			$jsOuput .= 'Glizy.pageContent.internalLinks = ['.implode(',', $internalLinks).'];'.GLZ_COMPILER_NEWLINE2;

			// link glossario
			// TODO: creare un plugin per aggiungere funzionalità tipo questa
			$it = org_glizy_ObjectFactory::createModelIterator( 'org.minervaeurope.museoweb.models.Glossary', 'all', array( 'order' => 'glossarydetail_term ASC' ) );
			$glossaryLinks = array();
			while( $it->hasMore() )
			{
				$arC = $it->current();
				$it->next();
				$glossaryLinks[] = '"'.glz_encodeOutput( $arC->glossarydetail_term ).'"';
			}
			$jsOuput .= 'Glizy.pageContent.glossaryLinks = ['.implode(',', $glossaryLinks).'];'.GLZ_COMPILER_NEWLINE2;


			$jsOuput .= 'Glizy.pageContent.editorImgPicker = "../../../../../../../../'.org_glizy_Paths::get('PAGE_FOLDER').'/index.php?pageId=imagePickerTiny";'.GLZ_COMPILER_NEWLINE2;
			$jsOuput .= 'Glizy.pageContent.editorMediaPicker = "../../../../../../../../'.org_glizy_Paths::get('PAGE_FOLDER').'/index.php?pageId=mediaPickerTiny";'.GLZ_COMPILER_NEWLINE2;
			$jsOuput .= 'Glizy.pageContent.adminPath = "../../../../../../../../'.org_glizy_Paths::get('PAGE_FOLDER').'/";'.GLZ_COMPILER_NEWLINE2;
			$jsOuput .= 'Glizy.pageContent.imgResizer = "getImage.php";'.GLZ_COMPILER_NEWLINE2;
		
			$this->addParentOutputCode( org_glizy_helpers_JS::JScode('Glizy.templatePath = "'.org_glizy_Paths::get('APPLICATION_TEMPLATE').'";'.GLZ_COMPILER_NEWLINE2), 'head');
			
		}
		
		$jsOuput .= 'Glizy.pageContent.iconPath = "'.org_glizy_Paths::get('CORE_STATIC_DIR').'assets/images/";'.GLZ_COMPILER_NEWLINE2;
		$this->serializeJs($this->_output, $jsOuput, 'Glizy.pageContent');
		$jsOuput .= '</script>'.GLZ_COMPILER_NEWLINE2;
		$this->addParentOutputCode($jsOuput);
		//$jsOuput  = '<script type="text/javascript" src="../static/org_glizy/assets/js/ja/ja.js"></script>'.GLZ_COMPILER_NEWLINE2;
		
		if (!is_null($this->getAttribute('label')))
		{
			$output = '<p class="genericCaption">'.$this->getAttribute('label').'</p>';	
			$this->addParentOutputCode($output);
		}
		
		$this->addParentOutputCode(org_glizy_helpers_JS::linkCoreJSfile('Glizy_pageContent.js?v='.GLZ_CORE_VERSION));
	}
	
	function addOutputCode($output, $componentId='')
	{
		if (is_array($output)) $this->_output[] = $output;
	}


	function serializeJs(&$node, &$output, $parent='pageContent', $initRoot=false)
	{
		if ($initRoot)
		{
			$output .= $parent.' = {};'.GLZ_COMPILER_NEWLINE2;
		}
		foreach ($node as $key=>$values)
		{
			if (is_array($values))
			{
				$childrens = isset($values['childrens']) ? $values['childrens'] : NULL;
				unset($values['childrens']);
				$items = isset($values['items']) ? $values['items'] : NULL;
				unset($values['items']);
				if ( $values['id'] == "id" ) $values['id'] = "__id__";
	
				$output .= $parent.'.'.$values['id'].' = {';
				$attributes = array_keys($values);
				for($i=0; $i<count($attributes); $i++)
				{
					$attributeName = $attributes[$i];
					$attributeValue = !is_null($values[$attributeName]) ? $values[$attributeName] : '';
					if ($attributeName=='childrens') continue;
					$output .= $attributeName.': '.$this->_serializeJsValue($attributeValue);
					if ($i<count($attributes)-1) $output .= ', ';
				}
				$output .= '};'.GLZ_COMPILER_NEWLINE2;		
		
				if (!is_null($childrens))
				{
					$this->serializeJs($childrens, $output, $parent.'.'.$values['id']);	
				}
	
				if (!is_null($items))
				{
					$output .= $parent.'.'.$values['id'].'.items = [];'.GLZ_COMPILER_NEWLINE2;
					for($i=0; $i<count($items); $i++)
					{
						$output .= $parent.'.'.$values['id'].'.items['.$i.'] = {};'.GLZ_COMPILER_NEWLINE2;
						$this->serializeJs($items[$i], $output, $parent.'.'.$values['id'].'.items['.$i.']');
					}
				}
			}
			else
			{
				$output .= $parent.'.'.$key.' = '.$this->_serializeJsValue($values).GLZ_COMPILER_NEWLINE2;
			}
		}
	}
	
	function _serializeJsValue($value)
	{
		if (is_array($value))
		{
			$result = '[';
			for($i=0; $i<count($value); $i++)
			{
				$result .= $this->_serializeJsValue($value[$i]);
				if ($i<count($value)-1) $result .= ', ';
			}
			$result .= ']';
		}
		else if (is_string($value))
		{
			$result = '\''.addslashes($value).'\'';
		}
		else if (is_bool($value))
		{
			$result = $value ? 'true' : 'false';
		}
		else
		{
			$result = $value;
		}
		return $result;
	}
}
?>