<?php
/* SVN FILE: $Id$ */

/**
 * 
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   glizy.admin.components
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 admin component
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */

glz_import('org.glizy.admin.components.JSEditing');
glz_import('org.glizy.helpers.Navigation');

class org_glizy_admin_components_JSPageEdit extends org_glizy_admin_components_JSEditing
{	
	var $_pageId;
	var $_sessionEx;
	var $_versionStatus;
	var $_childsId;
	var $_pageVersions;
	var $_pageVersionId;
	var $_menuNode;
	
	/**
	 * Return the component information
	 * 
	 * @return	array	component informaton.
	 * @access	public
	 * @static
	 */
	function getInfo()
	{
		$info 					= parent::info();
		$info['name']			= 'JSPageEdit';
		$info['class'] 			= 'org.glizy.admin.components.JSPageEdit';
		$info['package'] 		= 'Glizy';
		$info['version'] 		= GLZ_CORE_VERSION;
		$info['author'] 		= 'Daniele Ugoletti';
		$info['author-email'] 	= 'daniele@ugoletti.com';
		$info['url'] 			= 'http://www.ugoletti.com';
		return $info;
	}
	

	/**
	 * Init
	 * 
	 * @return	void
	 * @access	public
	 */
	function init()
	{
		$this->defineAttribute('action', 		true, NULL, COMPONENT_TYPE_STRING);
	
		// call the superclass for validate the attributes
		parent::init();
	}
	
	/**
	 * Process
	 * 
	 * @return	boolean	false if the process is aborted
	 * @access	public
	 */
	function process()
	{
		$this->_childsId		= array();
		$controllerClass 		= &$this->getAttribute('controller');
		$this->_sessionEx		= org_glizy_ObjectFactory::createObject('org.glizy.SessionEx', $controllerClass->getId());
		$this->_pageId 			= $this->_sessionEx->get('recordId', NULL, true, true);
		org_glizy_ObjectValues::set('org.glizy.admin.JSPageEdit', 'recordId', $this->_pageId);
		// TODO
		// il salvataggio automatico del valore letto da $this->_sessionEx->get
		// non funziona bene
		// per quetso ho fatto il set del valore
		$this->_sessionEx->set('recordId', $this->_pageId);
		
		
		$siteMap = &org_glizy_ObjectFactory::createObject('org.glizy.application.SiteMapDB');
		$siteMap->getSiteArray();
		$this->_menuNode = &$siteMap->getNodeById($this->_pageId);
			
		
		// legge i contenuti della pagina
		$this->_versionStatus = 'PUBLISHED';
		
		switch (strtolower($this->getAttribute('action')))
		{
			case 'new':
				$this->_versionStatus =  $this->_user->acl('SiteMap','edit') ? 'PUBLISHED' : 'DRAFT';
				break;
			case 'edit':
				if ($this->_user->acl('SiteMap','edit'))
				{	
					// OK
				}
				else if ($this->_user->acl('SiteMap','editDraft'))
				{
					$this->_versionStatus = 'DRAFT';
				}
				else
				{
					// non ci sono i diritti
					// TODO
					// BACK
				}

				break;
			case 'editdraft':
				if ($this->_user->acl('EditRecord','editDraft'))
				{
					$this->_versionStatus = 'DRAFT';
				}
				else
				{
					// non ci sono i diritti
					// TODO
					// BACK
				}
				break;
			case 'up':
			case 'down':
				$siteMap = &org_glizy_ObjectFactory::createObject('org.glizy.application.SiteMapDB');
				$siteMap->getSiteArray();
				$menuNode = &$siteMap->getNodeById($this->_pageId);
				$parentNode = &$menuNode->parentNode();
				$childNodes = &$parentNode->childNodes();
				
				if (count($childNodes)>1)
				{
					$menuPos = -1;
					for ($i=0; $i<count($childNodes); $i++)
					{
						$childNodes[$i]->order = $i+1;
						if ($childNodes[$i]->id==$menuNode->id) $menuPos = $i;
					}
					
					if ($this->getAttribute('action')=='up' && $menuPos>0)
					{		
						$oldOrder 						= $childNodes[$menuPos-1]->order;
						$childNodes[$menuPos-1]->order 	= $childNodes[$menuPos]->order;
						$childNodes[$menuPos]->order 	= $oldOrder;
			
					}
					else if ($this->getAttribute('action')=='down' && $menuPos!=-1 && $menuPos<count($childNodes)-1)
					{
						$oldOrder 						= $childNodes[$menuPos+1]->order;
						$childNodes[$menuPos+1]->order 	= $childNodes[$menuPos]->order;
						$childNodes[$menuPos]->order 	= $oldOrder;	
					}
					
					for ($i=0; $i<count($childNodes); $i++)
					{
						$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.Menu');
						$ar->load($childNodes[$i]->id);
						$ar->menu_order = $childNodes[$i]->order;
						$ar->save();
					}
				}
				org_glizy_helpers_Navigation::gotoUrl($controllerClass->changeStateUrl('reset'));
				exit();
				break;
			case 'delete':
				$siteMap = &org_glizy_ObjectFactory::createObject('org.glizy.application.SiteMapDB');
				$siteMap->getSiteArray();
				$pagesId = $siteMap->getAllChildsId($this->_pageId);
				foreach($pagesId as $id)
				{
					$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.ContentVersion');
					$ar->modifyField('contentversion_status', 'defaultSelectValue', NULL);
					$iterator = $ar->loadQuery('all', array('filters' => array('contentversion_FK_menu_id' => $id)));
					
					while ($iterator->hasMore())
					{
						$arVersion = &$iterator->current();
						$arContent = org_glizy_ObjectFactory::createModel('org.glizy.models.Content');
						$arContent->modifyField('content_FK_language_id', 'defaultSelectValue', NULL);
						$iteratorContent = $arContent->loadQuery('all', array('filters' => array('content_FK_version_id' => $arVersion->getId())));
	
						while ($iteratorContent->hasMore())
						{
							$arContent2 = &$iteratorContent->current();
							$arContent2->delete();
							$iteratorContent->next();
						}
						$arVersion->delete();
						$iterator->next();
					}
					
					$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.MenuDetail');
					$iterator = $ar->loadQuery('all', array('filters' => array('menudetail_FK_menu_id' => $id)));
					while ($iterator->hasMore())
					{
						$arDetail = &$iterator->current();
						$arDetail->delete();
						$iterator->next();
					}
					
					$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.Menu');
					$ar->delete($id);
				}
				org_glizy_helpers_Navigation::gotoUrl($controllerClass->changeStateUrl('reset'));
				exit();
			case 'publish':
				$this->_publish();
				org_glizy_helpers_Navigation::gotoUrl($controllerClass->changeStateUrl('reset'));
				exit();
			case 'visible':
			case 'invisible':
				$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.MenuDetail');
				$result = $ar->find(array('menudetail_FK_menu_id' => $this->_pageId, 'menudetail_FK_language_id' => $this->_application->getEditingLanguageId()));
				if ($result)
				{
					$ar->menudetail_isVisible = $ar->menudetail_isVisible==1 ? 0 : 1;
					$ar->save();
				}
				org_glizy_helpers_Navigation::gotoUrl($controllerClass->changeStateUrl('reset'));
				exit();
			case 'lock':
				$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.Menu');
				$ar->load($this->_pageId);
				$ar->menu_isLocked = $ar->menu_isLocked==1 ? 0 : 1;
				if ( $ar->menu_isLocked == 0 )
				{
					$ar->setProcessRelations( true );
					$ar->aclFront = '';
				}
				$ar->save();
				org_glizy_helpers_Navigation::gotoUrl($controllerClass->changeStateUrl('reset'));
				exit();
		}

		$this->_loadPageContent();
		$this->_addChilds();
		$this->processChilds();
	}
	
	
	function loadContent($name, $bindToField=NULL)
	{
		if (empty($bindToField)) 
		{
			$bindToField = $name;
		}
		$bindToField = preg_replace('/^'.$this->getId().'\-/', '', $bindToField);
		if ( !in_array( $bindToField, $this->_childsId ) )
		{
			$this->_childsId[] = $bindToField;
		}
		
		
		return isset($this->_content[$bindToField]) ? $this->_content[$bindToField]['content_value'] : '';
	}
	
	function addOutputCode($output, $componentId='')
	{
		$output['id'] = preg_replace('/^'.$this->getId().'\-/', '', $output['id']);
		$output['id'] = str_replace('-', '___', $output['id']);
		parent::addOutputCode($output);
	}
	
	function render()
	{
		if (!is_null($this->getAttribute('label')))
		{
			$this->setAttribute('label', $this->getAttribute('label').': '.$this->_menuNode->title);	
		}
		
		$output = array();
		$output['id'] 		= $this->getId().'_action';
		$output['type'] 	= 'hidden';
		$output['value'] 	=  $this->getAttribute('action');
		parent::addOutputCode($output);

		$output = array();
		$output['id'] 		= $this->getId().'_pageId';
		$output['type'] 	= 'hidden';
		$output['value'] 	=  $this->_pageId;
		parent::addOutputCode($output);

		$output = array();
		$output['id'] 		= $this->getId().'_versionStatus';
		$output['type'] 	= 'hidden';
		$output['value'] 	=  $this->_versionStatus;
		parent::addOutputCode($output);
		
		$controllerClass 		= &$this->getAttribute('controller');
		$output = array();
		$output['id'] 		= $this->getId().'_resetUrl';
		$output['type'] 	= 'hidden';
		$output['value'] 	=  $controllerClass->changeStateUrl('reset');
		parent::addOutputCode($output);
		
		parent::render();	
	}
	

	
	function process_ajax()
	{
		$this->_childsId		= array();
		$ajaxResponse 			= array('status' => 'success');
		$values 				= org_glizy_Request::getAllAsArray();

		// override l'azione principale con quella passata tramite AJAX
		if (isset($values['ajaxProcessAction']) && in_array($values['ajaxProcessAction'], array('editDraft', 'publish')))
		{
			$values[$this->getId().'_action'] = $values['ajaxProcessAction'];
		}
		
		$this->_pageId			= $values[$this->getId().'_pageId'];
		org_glizy_ObjectValues::set('org.glizy.admin.JSPageEdit', 'pageId', $this->_pageId);
		$this->_versionStatus	= strtolower($values[$this->getId().'_action'])=='editdraft' ? 'DRAFT' : $values[$this->getId().'_versionStatus'];
		$this->_loadPageContent();
		foreach($values as $k=>$v)
		{
			$k = str_replace('___', '-', $k);
			if (isset($this->_content[$k])) 
			{
				$this->_content[$k]['content_value'] = $v;
				$this->_content[$k]['update'] = true;
			}
			else
			{
				$this->_content[$k] = array();
				$this->_content[$k]['content_value'] = $v;
			}
		}
		if ( isset( $values['menudetails_title'] ) )
		{
			$siteMap = &org_glizy_ObjectFactory::createObject('org.glizy.application.SiteMapDB');
			$siteMap->getSiteArray();
			$this->_menuNode = &$siteMap->getNodeById($this->_pageId);
			if ( $this->_menuNode->title != $values['menudetails_title'] )
			{
				$arDetails = org_glizy_ObjectFactory::createModel('org.glizy.models.MenuDetail');
				$arDetails->menudetail_FK_menu_id = $this->_pageId;
				$arDetails->menudetail_FK_language_id = $this->_application->getEditingLanguageId();
				if ( $arDetails->find() )
				{
					$arDetails->menudetail_title = $values['menudetails_title'];
					$arDetails->save();
				}
			}
			unset( $values['menudetails_title'] );
		}
		
		$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.ContentVersion');
		$this->_addChilds();
		//$this->_addChilds(); addChilds c' due volte, perch? e' un errore o una cosa voluta?
		$this->processChilds(); // il processChilds serve per creare eventuali figli di looper
		
		if (is_null($this->_pageVersionId))
		{
			$ar = org_glizy_ObjectFactory::createModel('org.glizy.models.ContentVersion');
			$ar->contentversion_FK_menu_id 	= $this->_pageId;
			$ar->contentversion_FK_user_id	= $this->_user->getId();
			$ar->contentversion_FK_language_id 	= $this->_application->getEditingLanguageId();
			$ar->contentversion_status 		= $this->_versionStatus;
			$ar->save();
			$this->_pageVersionId 			= $ar->getId();
		}

		// verifica se l'utente ha i permessi per compiere l'azione
		$values[$this->getId().'_action'] = $this->_user->checkActions($values[$this->getId().'_action'], array(
																		array('SiteMap', 'edit', 'edit', 'editDraft'),
																		array('SiteMap', 'editDraft', 'editDraft', ''),
																		array('SiteMap', 'new', 'new', '')
																		));
		switch (strtolower($values[$this->getId().'_action']))
		{
			case 'new':
			case 'edit':
			case 'editdraft':
				if (count($this->_childsId))
				{
					foreach($this->_childsId as $k)
					{
						$c = &$this->getComponentById($this->getId().'-'.$k);
						if (is_object($c) && method_exists($c, 'beforeInsertContent'))
						{
							$content = $c->beforeInsertContent($this->_content);
							if (is_null($content)) continue;
						}
						else
						{
							$content = $this->_content[$k];
						}
						if ( is_null( $content ) ) continue;
						$ar = &org_glizy_ObjectFactory::createModel('org.glizy.models.Content');
						if (isset($content['content_id']) && isset($content['update']))
						{
							// record gi presente						
							$ar->load($content['content_id']);
							$ar->content_value = $content['content_value'];
							$ar->save();
						}
						else if (!isset($content['content_id']))
						{
							$ar->content_value 			= $content['content_value'];
							$ar->content_FK_language_id = $this->_application->getEditingLanguageId();
							$ar->content_FK_menu_id 	= $this->_pageId;
							$ar->content_FK_version_id 	= $this->_pageVersionId;
							$ar->content_componentId 	= $k;
							$ar->save();	
						}
						unset( $ar );
					}
					$ar = &org_glizy_ObjectFactory::createModel('org.glizy.models.ContentVersion');				
					$ar->load($this->_pageVersionId);
					$ar->save();				
					unset( $ar );

					$ar = &org_glizy_ObjectFactory::createModel('org.glizy.models.Menu');
					$ar->load($this->_pageId);
					$ar->save();
					unset( $ar );
				}
				break;
			case 'publish':
				$this->_publish();
				break;
			default:
				return $ajaxResponse['status'] = 'error';
		}
		
		if (isset($values['ajaxProcessAction']))
		{
			switch (strtolower($values['ajaxProcessAction']))
			{
				case 'close':
				case 'editdraft':
				case 'newdraft':
				case 'publish':
					$ajaxResponse['action'] = 'redirect';
					$ajaxResponse['actionValue'] = $values[$this->getId().'_resetUrl'];
					break;	
			}
		} 

		return $ajaxResponse;
	}

	function _loadPageContent()
	{
		$this->_pageVersion = org_glizy_ObjectFactory::createModel('org.glizy.models.ContentVersion');
		$result = $this->_pageVersion->find(array('contentversion_FK_menu_id' => $this->_pageId, 'contentversion_status' => $this->_versionStatus, 'contentversion_FK_language_id' => $this->_application->getEditingLanguageId() ));
		

		if ( is_null($result) && strtolower($this->getAttribute('action')) )
		{
			// se non c' una versione bozza carica i dati dalla versione pubblicata
			$result = $this->_pageVersion->find(array('contentversion_FK_menu_id' => $this->_pageId, 'contentversion_status' => 'PUBLISHED', 'contentversion_FK_language_id' => $this->_application->getEditingLanguageId()));
		}
		$this->_pageVersionId = $this->_pageVersion->getId();
		
		$this->_content = array();
		if ($result)
		{
			$arContent = org_glizy_ObjectFactory::createModel('org.glizy.models.Content');
			$iterator = $arContent->loadQuery('all', array('filters' => array('content_FK_version_id' => $this->_pageVersionId, 'content_FK_language_id' => $this->_application->getEditingLanguageId())));
			while ($iterator->hasMore())
			{
				$ar = $iterator->current();
				$values = $ar->getValuesAsArray();
				$this->_content[$values['content_componentId']] = $values;
				$iterator->next();
			}
		}
		$this->_content[ 'menudetails_title' ] = array( "content_value" => $this->_menuNode->title );
	}
	
	function _addChilds()
	{
		// crea i figli
		$menu = org_glizy_ObjectFactory::createModel('org.glizy.models.Menu');
		$menu->load($this->_pageId);
		
		$templateFolder = org_glizy_Paths::get('APPLICATION_STATIC').'templates/'.org_glizy_Registry::get( __Config::get( 'REGISTRY_TEMPLATE_NAME' ), '');

		$originalRootComponent 	= &$this->_application->getRootComponent();
		$this->_pageTypeObj  	= &org_glizy_ObjectFactory::createPage($this->_application, $menu->menu_pageType, org_glizy_Paths::get('APPLICATION_TO_ADMIN_PAGETYPE'), array('idPrefix' => $this->getId().'-', 'skipImport' => true, 'pathTemplate' => $templateFolder ));
		$rootComponent			= &$this->_application->getRootComponent();
		$rootComponent->init();
		$this->_application->_rootComponent = &$originalRootComponent;
		$editComponents = $rootComponent->getAttribute('adm:editComponents');
		if (count($editComponents))
		{
			foreach($editComponents as $id)
			{
				$component = &$rootComponent->getComponentById($this->getId().'-'.$id);
				if (!is_object($component)) continue;
				$component->remapAttributes($this->getId().'-');
				$this->addChild($component);
				$component->_parent = &$this;
				$component->setAttribute('visible', true);
			}
		}
		else
		{
			for($i=0; $i<count($rootComponent->childComponents); $i++)
			{
				$rootComponent->childComponents[$i]->remapAttributes($this->getId().'-');
				$this->addChild($rootComponent->childComponents[$i]);
				$rootComponent->childComponents[$i]->_parent = &$this;
			}
		}
		
	}
	
	function _publish()
	{
		$ar 	= org_glizy_ObjectFactory::createModel('org.glizy.models.ContentVersion');
		$result = $ar->find(array('contentversion_FK_menu_id' => $this->_pageId, 'contentversion_status' => 'PUBLISHED', 'contentversion_FK_language_id' => $this->_application->getEditingLanguageId()));
		if ($result)
		{
			$ar->contentversion_status = 'OLD';
			$ar->save();
		}	

		$ar 	= org_glizy_ObjectFactory::createModel('org.glizy.models.ContentVersion');
		$result = $ar->find(array('contentversion_FK_menu_id' => $this->_pageId, 'contentversion_status' => 'DRAFT', 'contentversion_FK_language_id' => $this->_application->getEditingLanguageId()));
		if ($result)
		{
			$ar->contentversion_status = 'PUBLISHED';
			$ar->save();
		}
	}
	
	// ** //
	function getJSpagePreview( $draft=false )
	{
		return 'Glizy.pageContent.pagePreview('.$this->_pageId.', '.($draft ? '1' : '0').', \''.org_glizy_Config::get('SESSION_PREFIX').'\')';
	}
}
?>