<?php
/* SVN FILE: $Id$ */

/**
 * Application  class.
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   glizy.application
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 core class
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */

glz_import('org.glizy.application.SiteMap');
glz_import('org.glizy.dataAccess.ActiveRecord');
		
class org_glizy_application_SiteMapDB extends org_glizy_application_SiteMap
{
	var $_type = 'db';
	
	function loadTree($forceReload=false)
	{
		if ($forceReload) $this->init();

		$application = &org_glizy_ObjectValues::get('org.glizy', 'application');
		$isAdmin = $application->isAdmin();
		$user = &$application->getCurrentUser();
		$showDraft = false;
		$showDraft = isset($_GET['draft']) && $_GET['draft'] == '1';
		$languageId = method_exists($application, 'getEditingLanguageId') ? $application->getEditingLanguageId() : $application->getLanguageId();
		
		// carica le versioni dei vari men
		// per poter disabilitare i men che hanno solo la versione bozza
		$menuVersion = array();
		$it = &org_glizy_ObjectFactory::createModelIterator('org.glizy.models.ContentVersion', 'all', array('filters' => array( 'contentversion_status' =>  'DRAFT', 'contentversion_FK_language_id' => $languageId ) ) );
		
		while ( $it->hasMore() )
		{
			$arC = &$it->current();
			$it->next();
			$menuVersion[ $arC->contentversion_FK_menu_id ] = false;
		}
		$it = &org_glizy_ObjectFactory::createModelIterator('org.glizy.models.ContentVersion', 'all', array('filters' => array( 'contentversion_status' =>  'PUBLISHED', 'contentversion_FK_language_id' => $languageId ) ) );
		while ( $it->hasMore() )
		{
			$arC = &$it->current();
			$it->next();
			$menuVersion[ $arC->contentversion_FK_menu_id ] = true;
		}
		
		
		$m = &org_glizy_ObjectFactory::createModel('org.glizy.models.Menu');
		$iterator 	= &$m->loadQuery('getAllMenu', array('params' => array($languageId)));
		$isAdmin = org_glizy_ObjectValues::get('org.glizy', 'admin', false);
		$hidePrivatePage = org_glizy_Config::get( 'HIDE_PRIVATE_PAGE', true );

		while ($iterator->hasMore())
		{
			$ar = &$iterator->current();
			$iterator->next();
			
			$menu 					= $this->getEmptyMenu();
			$menu['id'] 			= $ar->menu_id;
			$menu['parentId'] 		= $ar->menu_parentId;
			$menu['pageType'] 		= $ar->menu_pageType;
			$menu['isVisible'] 		= $ar->isVisible == 1 ? true : false;
			
			if ( isset( $menuVersion[$ar->menu_id] ) && !$isAdmin )
			{
				if ( !$menuVersion[$ar->menu_id] && $showDraft && $user->backEndAccess) 
				{
					$menu['isVisible'] = true;
				}
				else
				{
			//		$menu['isVisible'] = $menuVersion[ $ar->menu_id ];
				}
			}
			
			$menu['title'] 			= str_replace( "\n", " ", $ar->title );
			$menu['titleLink'] 			= $ar->titleLink;
			$menu['linkDescription'] 	= $ar->linkDescription;
			$menu['depth'] 			= 1;
			$menu['childNodes'] 	= array();
			$menu['isLocked']		= $ar->menu_isLocked == '1';
			$menu['url']			= $ar->menu_url;
			$menu['moduleClass'] 	= $ar->menu_moduleClass;
			$menu['showTitle'] 		= $ar->menu_showTitle;

			// solo admin
			$menu['order'] 				= $ar->menu_order;
			$menu['type'] 				= $ar->menu_type;
			$menu['creationDate'] 		= $ar->menu_creationDate;
			$menu['modificationDate'] 	= $ar->menu_modificationDate;
			$menu['hasComment'] 		= $ar->menu_hasComment;
			$menu['printPdf'] 			= $ar->menu_printPdf;
			$menu['nodeObj'] 			= NULL;
			
			if ( !$isAdmin && $menu['isLocked'] && !$this->_user->isLogged() && $hidePrivatePage ) continue;
			$this->_siteMapArray[$menu["id"]] = $menu;
		}

		$this->_makeChilds();
	}
}
?>