<?php
/* SVN FILE: $Id$ */

/**
 * 
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   glizy.components
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 core class
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */
 
glz_import('org.glizy.components.Component');
glz_import('org.glizy.dataAccess.DataAccess');

class org_glizy_components_DataDictionary extends org_glizy_components_Component
{	
	var $_activeRecord;
	
	/**
	 * Return the component information
	 * 
	 * @return	array	component informaton.
	 * @access	public
	 * @static
	 */
	function getInfo()
	{
		$info 					= parent::info();
		$info['name']			= 'DataDictionary';
		$info['class'] 			= 'org.glizy.components.DataDictionary';
		$info['package'] 		= 'Glizy';
		$info['version'] 		= '1.1.0';
		$info['author'] 		= 'Daniele Ugoletti';
		$info['author-email'] 	= 'daniele@ugoletti.com';
		$info['url'] 			= 'http://www.ugoletti.com';
		return $info;
	}

	
	/**
	 * Init
	 * 
	 * @return	void
	 * @access	public
	 */
	function init()
	{
		$this->defineAttribute('recordClassName',	true, 	'',		COMPONENT_TYPE_STRING);
		$this->defineAttribute('query', 			false,	NULL,	COMPONENT_TYPE_STRING);
		$this->defineAttribute('field', 			false,	NULL,	COMPONENT_TYPE_STRING);
		$this->defineAttribute('skipEmpty', 		false,	true,	COMPONENT_TYPE_BOOLEAN);
		$this->defineAttribute('delimiter', 		false,	'',	COMPONENT_TYPE_STRING);
		parent::init();
	}	


	/**
	 * Process
	 * 
	 * @return	boolean	false if the process is aborted
	 * @access	public
	 */
	function process()
	{	
		$classPath 	= $this->getAttribute('recordClassName');
		if (is_null($classPath))
		{
			// TODO
			// visualizzare FATAL ERROR
			$this->RaiseError("DataProvider: record class don't found",__FUNCTION__,__FILE__,__LINE__,'verbosedie');
		}
		else
		{
			$this->_activeRecord = &org_glizy_ObjectFactory::createModel($classPath);
			if ($this->_activeRecord===false)
			{
				// TODO
				// visualizzare FATAL ERROR
				$this->RaiseError("DataProvider: record class don't found",__FUNCTION__,__FILE__,__LINE__,'verbosedie');
			}
		}
	}

	function getItems()
	{
		if ( is_null( $this->_activeRecord ) )
		{
			$this->process();
		}
		$items = org_glizy_ObjectValues::get('org.glizy.components.DataDictionary', $this->getAttribute('recordClassName').'.'.$this->getAttribute('field').$this->getAttribute('query'));
		if (is_null($items))
		{
			$items = __Session::get($this->getAttribute('recordClassName').'.'.$this->getAttribute('field').$this->getAttribute('query') );
		}

		if (is_null($items) )
		{
			$items = $this->_activeRecord->loadDictionary(	$this->getAttribute('field'),
															$this->getAttribute('query'),
															$this->getAttribute('skipEmpty'),
															$this->getAttribute('delimiter') );
			org_glizy_ObjectValues::set('org.glizy.components.DataDictionary', $this->getAttribute('recordClassName').'.'.$this->getAttribute('field').$this->getAttribute('query'), $items);
			if ( $this->getAttribute('delimiter') != '' )
			{
				__Session::set($this->getAttribute('recordClassName').'.'.$this->getAttribute('field').$this->getAttribute('query'), $items);
			}
		}
		return $items;
	}
}
?>