<?php
/* SVN FILE: $Id$ */

/**
 * 
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   glizy.components
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 core class
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */
 
glz_import('org.glizy.components.Component');
glz_import('org.glizy.helpers.Navigation');

class org_glizy_components_Logout extends org_glizy_components_Component
{	
	var $_error = NULL;
	
	/**
	 * Return the component information
	 * 
	 * @return	array	component informaton.
	 * @access	public
	 * @static
	 */
	function getInfo()
	{
		$info 					= parent::info();
		$info['name']			= 'Logout';
		$info['class'] 			= 'org.glizy.components.Logout';
		$info['package'] 		= 'Glizy';
		$info['version'] 		= GLZ_CORE_VERSION;
		$info['author'] 		= 'Daniele Ugoletti';
		$info['author-email'] 	= 'daniele@ugoletti.com';
		$info['url'] 			= 'http://www.ugoletti.com';
		return $info;
	}
	
	/**
	 * Init
	 * 
	 * @return	void
	 * @access	public
	 */
	function process()
	{
		org_glizy_Session::start();
		$evt = array('type' => GLZ_EVT_USERLOGOUT, 'data' => '');
		$this->dispatchEvent($evt);

		if (org_glizy_Config::get('USER_LOG'))
		{
			$user = org_glizy_Session::get('glizy.user');
			$arLog = &org_glizy_ObjectFactory::createModel('org.glizy.models.UserLog');
			$arLog->load($user['logId']);
			$arLog->delete();
		}
		
		org_glizy_Session::removeAll();
		setcookie( "glizy_username", "", time()-3600 );
		setcookie( "glizy_password", "", time()-3600 );
		
		org_glizy_helpers_Navigation::gotoUrl( GLZ_HOST );
		exit();
	}
}
?>