<?php
/* SVN FILE: $Id$ */

/**
 * 
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   glizy.dataAccess
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 core class
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */

define( 'AR_TYPE_STRING', 'string' );
define( 'AR_TYPE_VERSIONDATE', 'versiondate' );
define( 'AR_TYPE_VERSIONSTATUS', 'versionstatus' );
define( 'AR_TYPE_ENUM', 'enum' );
define( 'AR_TYPE_LANGUAGE', 'language' );
define( 'AR_TYPE_USER', 'user' );
define( 'AR_TYPE_INTEGER', 'integer' );
define( 'AR_TYPE_INT', 'int' );
define( 'AR_TYPE_TEXT', 'text' );
define( 'AR_TYPE_RICHTEXT', 'richtext' );
define( 'AR_TYPE_SITEID', 'siteid' );
define( 'AR_TYPE_DATE', 'date' );
define( 'AR_TYPE_DATETIME', 'datetime' );
define( 'AR_TYPE_ACL', 'acl' );
define( 'AR_TYPE_CATEGORY', 'category' );
define( 'AR_TYPE_VIRTUAL', 'virtual' );

include_once('driver/Connection.php');
include_once('ActiveRecord.php');
include_once('ActiveRecord2tables.php');
include_once('RecordIterator.php');
include_once('ActiveRecord_relation.php');
include_once('ActiveRecord_relation_hasMany.php');
include_once('ActiveRecord_relation_hasOne.php');
include_once('ActiveRecord_relation_many2Many.php');
include_once('ActiveRecord_relation_joinTable.php');

class org_glizy_dataAccess_DataAccess
{
	function &getConnection($n=0)
	{
		static $instance = array();
		if ( __Config::get( 'DB_LAYER' ) == 'adodb' )
		{
			if (!isset($instance['__'.$n])) 
			{
				glz_importLib( 'adodb/adodb.inc.php' );
				if ($n==0)
				{
					$instance['__'.$n] = &ADONewConnection(org_glizy_Config::get('DB_TYPE'), 'pear:meta');
					$instance['__'.$n]->Connect(org_glizy_Config::get('DB_HOST'), org_glizy_Config::get('DB_USER'), org_glizy_Config::get('DB_PSW'), org_glizy_Config::get('DB_NAME'));
				}
				else
				{
					$type = org_glizy_Config::get('DB_TYPE#'.$n);
					if (is_null($type)) $type = org_glizy_Config::get('DB_TYPE');
					$instance['__'.$n] = &ADONewConnection($type, 'pear:meta');
					$instance['__'.$n]->Connect(org_glizy_Config::get('DB_HOST#'.$n), org_glizy_Config::get('DB_USER#'.$n), org_glizy_Config::get('DB_PSW#'.$n), org_glizy_Config::get('DB_NAME#'.$n));
				}
			}
			
			//$instance['__'.$n]->execute( "SET lc_time_names = 'it_IT';" );
		}
		else
		{
			if (!isset($instance['__'.$n])) 
			{
				$options = array();
				$sufix = $n == 0 ? '' : '#'.$n;
				switch ( __Config::get( 'DB_TYPE'.$sufix ) )
				{
					case 'sqlite':
						$dsn = 'sqlite:'.__Paths::getRealPath( 'APPLICATION', 'data/'.__Config::get( 'DB_NAME'.$sufix ) );
						$dbUser = '';
						$dbPassword = '';
						break;
					default:
						$socket = __Config::get( 'DB_SOCKET'.$sufix );
						$socket = empty( $socket ) ? '' : ';unix_socket='.$socket;
						$dsn = 'mysql:dbname='.__Config::get( 'DB_NAME'.$sufix ).';host='.__Config::get( 'DB_HOST'.$sufix ).$socket;
						$dbUser = __Config::get( 'DB_USER'.$sufix );
						$dbPassword = __Config::get( 'DB_PSW'.$sufix );
						if ( __Config::get( 'CHARSET' ) == 'utf-8' )
						{
							$options = array(PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES utf8");
						}
						if ( __Config::get( 'DB_MYSQL_BUFFERED_QUERY' ) )
						{
							$options[ PDO::MYSQL_ATTR_USE_BUFFERED_QUERY ] = true;
						}
						break;
				}
				
				$instance['__'.$n] = new Connection( $dsn, $dbUser, $dbPassword, $options );
			}
		}
	
		
		return $instance['__'.$n];
	}
	
	function qstr($value, $n=0)
	{
		$conn = &org_glizy_dataAccess_DataAccess::getConnection($n);
		return $conn->qstr($value, false);
	}
	
	
	function close($n=0)
	{
		$conn = org_glizy_dataAccess_DataAccess::getConnection($n);
		$conn->close();
	}
	
	function getMetaColumns($table, $usePrefix=true, $n=0)
	{
		$prefix = $usePrefix!=false ? org_glizy_dataAccess_DataAccess::getTablePrefix( $n ) : '';
		$conn = org_glizy_dataAccess_DataAccess::getConnection($n);
		$conn->SelectDB($conn->database);
		return $conn->MetaColumns($prefix.$table, true);
	}
	
	function getTablePrefix( $n=0 )
	{
		return org_glizy_Config::get( $n== 0 ? 'DB_PREFIX' : 'DB_PREFIX#'.$n);
	}
	
	function selectDB( $n=0 )
	{
		$conn = org_glizy_dataAccess_DataAccess::getConnection($n);
		$conn->SelectDB( $conn->database );
	}
}


function glz_DBdebug($state, $n=0)
{
	$conn = &org_glizy_dataAccess_DataAccess::getConnection($n);
	$conn->debug = $state;
}