<?php
/* SVN FILE: $Id$ */

/**
 * 
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   glizy.plugins
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 core class
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */
 
glz_import('org.glizy.plugins.PluginServer');

class org_glizy_plugins_Search extends org_glizy_plugins_PluginServer
{		
	function run($params)
	{
		$application = &org_glizy_ObjectValues::get('org.glizy', 'application');
		$siteMap = $application->getSiteMap();
		$whereSql = array();
		foreach ($params as $word)
		{
			$whereSql[] = 'content_value LIKE '.org_glizy_dataAccess_DataAccess::qstr('%'.$word.'%');
		}
		if ( count( $whereSql ) ) 
		{
			$foundMenu	= array();
			$ar 		= org_glizy_ObjectFactory::createModel('org.glizy.models.Content');
			$iterator 	= $ar->loadQuery('all', array('filters' => '('.implode(' '.__Config::get( 'GLIZY_SEARCH_PLUGIN_CONDITION' ).' ', $whereSql).')'));
			while ($iterator->hasMore())
			{
				$arContent = &$iterator->current();
				if (!in_array($arContent->content_FK_menu_id, $foundMenu))
				{				
					$arDet 		= org_glizy_ObjectFactory::createModel('org.glizy.models.MenuDetail');
					$r = $arDet->find(array(	'menudetail_FK_language_id' => $application->getLanguageId(),
												'menudetail_FK_menu_id' => $arContent->content_FK_menu_id));
					if ($arDet->menudetail_isVisible==1) 
					{
						// controlla se la pagina padre  di sistema 
						// in questo caso non include la pagina nella ricerca
						$menu = &$siteMap->getNodeById( $arContent->content_FK_menu_id );
						if ( is_object( $menu ) )
						{	
							$content = strip_tags( $arContent->content_value );
							$accept = false;
							foreach( $params as $v )
							{
								if ( stripos( $content, $v ) !== false )
								{
									$accept = true;
								}
							}
							if ( $accept )
							{
								$parentMenu = &$menu->parentNode();
								$parentMenu2 = &$menu->parentNodeByDepth( 2 );
								if ( $parentMenu->type != 'SYSTEM' && $parentMenu2->type != 'SYSTEM' )
								{
									$result 			= $this->getResultStructure();
									$result['title'] 	= $arDet->menudetail_title;
									$result['description'] 	= $arDet->menudetail_description;
									$result['__url__'] 	= org_glizy_helpers_Link::makeLink('link', array('pageId' => $arContent->content_FK_menu_id, 'title' => $arDet->menudetail_title));
									$this->addResult($result);
								}
							}
						}
					}
					$foundMenu[] = $arContent->content_FK_menu_id;
				
				}
				$iterator->next();
			}
			$this->runClients($params);
		}	
		
		return $this->getResult();
	}
	
	function addResult($result)
	{
		$result['__weight__'] = str_pad( $result['__weight__'], 6, "0", STR_PAD_LEFT ).$result['title'];
		$this->_output[] = $result;
	}
	
	function getResultStructure()
	{
		$result = array();
		$result['title']	= '';
		$result['date']	= '';
		$result['dateOrd']	= '';
		$result['description']	= '';
		$result['__url__'] 		= '';
		$result['__weight__'] 	= 0;
	}
}
?>