<?php
/* SVN FILE: $Id$ */

/**
 * Glizy main core file.
 * This file must be included for use the Glizy framework.
 *
 * This file is part of the GLIZY framework.
 * Copyright (c) 2005-2006 Daniele Ugoletti <daniele@ugoletti.com>
 * 
 * For the full copyright and license information, please view the COPYRIGHT.txt
 * file that was distributed with this source code.
 *
 * @copyright    Copyright (c) 2005, 2006 Daniele Ugoletti
 * @link         http://www.glizy.org Glizy Project
 * @license      http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 * @package      glizy
 * @subpackage   core
 * @author		 Daniele Ugoletti <daniele@ugoletti.com>
 * @category	 script
 * @since        Glizy v 0.01
 * @version      $Rev$
 * @modifiedby   $LastChangedBy$
 * @lastmodified $Date$
 */

// ini_set( "display_errors", "on" );
// ini_set( "display_startup_errors", "on" );

if ( !defined( 'E_DEPRECATED' ) )
{
    define( 'E_DEPRECATED', 8192 );
}
if ( !defined( 'E_STRICT' ) )
{
    define( 'E_STRICT', 2048 );
}

date_default_timezone_set('Europe/Rome');
$errorlevel=error_reporting();
error_reporting($errorlevel & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT);

set_include_path('./' . PATH_SEPARATOR . get_include_path());
require_once(dirname(__FILE__) . '/functions.inc.php');
set_error_handler('glz_exception_handler', E_ALL);

// define
require_once(dirname(__FILE__) . '/defines.inc.php');

if ( phpversion() < 5)
{
	glz_import('org.glizy.Exception');	
	org_glizy_Exception::show( 500, "GLIZY work only with php 5", "", "");
}


// import all the libraries
glz_require_once_dir(GLZ_LIBS_DIR);

// import the main Object class
glz_import('org.glizy.GlizyObject');

// import the needed classes for start-up a application
glz_import('org.glizy.locale.Locale');
glz_import('org.glizy.*');
glz_import('org.glizy.components.Component');
glz_import('org.glizy.components.ComponentContainer');


function __autoload( $className )
{
	$className = str_replace( '_', '.', $className );
	glz_import( $className );
}
?>